//---------------------------------------------------------------------------
#pragma hdrstop

#include "DecoderU.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
//
__fastcall TDetectorO::TDetectorO(void) : TObject()
{
  int      i,j;                                                 // 
  String   FileName;                                            // 
  DWORD    Cl_Byte;                                             // 
  HWND     FHnd;                                                //  

  FileName = ExtractFilePath(ParamStr(0))+"Settings.bin";       //   
  if(FileExists(FileName))                                      //    
  {
    // (  )
    FHnd = CreateFile(FileName.c_str(),
                      GENERIC_READ | GENERIC_WRITE,
                      0,
                      NULL,
                      OPEN_ALWAYS,
                      FILE_ATTRIBUTE_NORMAL,
                      0);
    if(FHnd != INVALID_HANDLE_VALUE)                            //  
    {
      ReadFile(FHnd,&Settings,sizeof(Settings),&Cl_Byte,NULL);  // 
      CloseHandle(FHnd);                                        // 
    }
  }
  else DefSettings();                                           //  

  Color_Rd = False;                                             //  
  Color_Gr = False;
  Color_Wh = False;
  Debug_Inf = False;                                            //  

  Col_Porog.Red_Max = 100;                                      // 
  Col_Porog.Red_G = 80;                                         //  
  Col_Porog.Red_B = 70;

  Col_Porog.Green_Max = 50;                                     // 
  Col_Porog.Green_R = 60;                                       //  
  Col_Porog.Green_B = 50;

  Col_Porog.BW_Max = 170;                                       //  

  for(i=1;i<=szColPB;i++)                                       //    
  {
    ColP_Buf.Bf_RG[i] = Col_Porog.Red_G*2;                      //    
    ColP_Buf.Bf_RB[i] = Col_Porog.Red_B*2;
    ColP_Buf.Bf_GB[i] = Col_Porog.Green_B*2;
  }
  ColP_Buf.Pointer = 1;                                         //  
  ColP_Buf.Taimer = 0;                                          //   

  Init_OK = False;                                              //  
  Gl_Last_Nomer = Bol_Netu;                                     //  
  Color_An_Frame = 0;                                           //     
  Text_Im = new Graphics::TBitmap();                            // 
  Text_Im->PixelFormat = pf24bit;                               // 
  Text_Im->Width  = 100;                                        //
  Text_Im->Height = 100;
  StP.St_Ind = 0;                                               //  
  Center_Bufer.Ind = 0;                                         //    
  Gl_Width = 0;                                                 //
  Gl_Height = 0;
  Gl_Mode = mdGameOK;                                           // 
  for(i=1;i<=maxLstNom;i++) Buf_Nomer.N_Arr[i] = Bol_Netu;      // 
  Koleso.Last_Green_Ugol = 0;                                   //   
  for(i=1;i<=30;i++) Koleso.Ugl_Speed[i] = 0;                   // 
  for(j=1;j<=50;j++)                                            //    
  {
    //   
    for(i=1;i<=10;i++) Bols_Koord.Bols_St[j][i] = Point(0,0);
  }
  Bols_Koord.WrP_Fr = 1;                                        //   
  Bols_Koord.WrP_Bl = 1;                                        //   
  Koleso.Last_Angle_Diff = 0;                                   //   

  for(i=1;i<=50;i++)                                            // 
  {
    TestP[i][1] = Point(0,0);
    TestP[i][2] = Point(0,0);
  }
}
//---------------------------------------------------------------------------
//
__fastcall TDetectorO::~TDetectorO(void)
{
  int      i;                                                   // 
  SeveSettings();                                               //    
  Text_Im->Free();                                              // 
}
//---------------------------------------------------------------------------
//    
void __fastcall TDetectorO::SeveSettings(void)
{
  String   FileName;                                            // 
  DWORD    Cl_Byte;                                             // 
  HWND     FHnd;                                                //  

  FileName = ExtractFilePath(ParamStr(0))+"Settings.bin";       //   

  // (  )
  FHnd = CreateFile(FileName.c_str(),
                    GENERIC_READ | GENERIC_WRITE,
                    0,
                    NULL,
                    OPEN_ALWAYS,
                    FILE_ATTRIBUTE_NORMAL,
                    0);
  if( FHnd != INVALID_HANDLE_VALUE)                             //  
  {
    WriteFile(FHnd,&Settings,sizeof(Settings),&Cl_Byte,NULL);   // 
    CloseHandle(FHnd);                                          // 
  }
}
//---------------------------------------------------------------------------
//  
void __fastcall TDetectorO::DefSettings(void)
{
  Settings.MaxPl_RG = 45;                                       //  
  Settings.MaxPl_RB = 45;
  Settings.MaxPl_GR = 17;
  Settings.MaxPl_GB = 20;

  Settings.Wh_Pers = 8;                                         //   
  Settings.OffAngSpd = 1;                                       //  
  Settings.Edge_Nom = 6;                                        //   

  Settings.Alt_White = 0;                                       //   
  Settings.Alt_Level = 160;                                     //   
  Settings.Eccentricity = 0.64;                                 // (  )
  //    
  Settings.Compression = sqrt(1-SQR(Settings.Eccentricity));
  Settings.Rotation = 0;                                        //  
  Settings.ApdMD = 0;                                           //   
  Settings.MatrixLev = 75;                                      //   
  Settings.ClWhDelt = 100;                                      //    
  Settings.MaxRBolAr = 90;                                      //    
}
//---------------------------------------------------------------------------
//    
bool __fastcall TDetectorO::IsSingle(TMov_Detector *Det, int APoz)
{
  int  PrevPoz;                                                 // 
  int  NextPoz;                                                 // 

  PrevPoz = APoz-1;                                             // 
  if(PrevPoz <= 0) PrevPoz = 180;                               //
  NextPoz = APoz+1;                                             // 
  if(NextPoz > 180) NextPoz = 1;                                //

  //      -   
  if(Det->Arr_Det[APoz].Bol && (Det->Arr_Det[PrevPoz].Bol == False) && (Det->Arr_Det[NextPoz].Bol == False)) return True;
  else                                                                                                    return False;
}
//---------------------------------------------------------------------------
//   
bool __fastcall TDetectorO::IsItMovBol(TMov_Detector *Det, int FreshPoz)
{
  int          i;                                               // 
  bool         Flag_Ok;                                         //  
  int          ADist[10];                                       //    
  int          Porog;                                           //     
  int          minDist;                                         //    
  int          maxDist;                                         //    

  Porog = 6;                                                    //     

  Flag_Ok = False;                                              // 
  //     -     
  if(SizeMovObj(Det) > Porog) { for(i=1;i<=10;i++) Det->St_Koord[i] = 0; }
  else                                                          //     
  {
    for(i=10;i>=2;i--) Det->St_Koord[i] = Det->St_Koord[i-1];   // 
    Det->St_Koord[1] = Det->Old_Poz;                            // 

    for(i=1;i<=9;i++)                                           //   -1
    {
     //   
     ADist[i] = RingDistance180(Det->St_Koord[i],Det->St_Koord[i+1]);
    }

    Flag_Ok = True;                                             //   
    //   
    minDist = 5;
    maxDist = 150;
    for(i=1;i<=3;i++)                                           //    
    {
      //        -  
      if((ADist[i] <= minDist)||(ADist[i] >= maxDist)) Flag_Ok = False;
    }

    if(Flag_Ok == False)                                        //  
    {
      Flag_Ok = True;                                           //   
      //   
      minDist = -150;
      maxDist = -5;
      for(i=1;i<=3;i++)                                         //    
      {
        //        -  
        if((ADist[i] <= minDist)||(ADist[i] >= maxDist)) Flag_Ok = False;
      }
    }
  }
  return Flag_Ok;                                               // 
}
//---------------------------------------------------------------------------
//  
int __fastcall TDetectorO::SizeMovObj(TMov_Detector *Det)
{
  int         i,j;                                              //
  int         ADist;                                            //   
  int         MaxSize;                                          // 
  int         T1,T2;                                            //  

  MaxSize = 0;                                                  // 
  for(i=1;i<=180;i++)                                           // 
  {
    if(Det->Arr_Det[i].Bol)                                     //   
    {
      T1 = i;                                                   //  ()  
      for(j=1;j<=180;j++)                                       // 
      {
        if(Det->Arr_Det[j].Bol)                                 //   
        {
          T2 = j;                                               //  ()  
          ADist = RingDistance180Abs(T1,T2);                    //   
          if(ADist >= MaxSize) MaxSize = ADist;                 // 
        }
      }
    }
  }
  return MaxSize;                                               //   
}
//---------------------------------------------------------------------------
//        180 
int __fastcall TDetectorO::RingDistance180Abs(int T1, int T2)
{
  int   Vr;                                                     // 
  int   D1,D2;                                                  //     

  if(T1 > T2)                                                   //   
  {
    Vr = T2;                                                    // 
    T2 = T1;
    T1 = Vr;
  }
  D1 = T2-T1;                                                   //   
  D2 = (180-T2)+T1;                                             //   

  if(D1 >= D2) return D2;                                       //  
  else         return D1;
}
//---------------------------------------------------------------------------
//       180 
int __fastcall TDetectorO::RingDistance180(int T1, int T2)
{
  int     Vr;                                                   // 
  int     D1,D2;                                                //     
  bool    Z;                                                    // 
  int     minD;                                                 // 

  if(T1 > T2)                                                   //   
  {
    Vr = T2;                                                    // 
    T2 = T1;
    T1 = Vr;
    Z = False;                                                  // 
  }
  else Z = True;                                                // 
  D1 = T2-T1;                                                   //   
  D2 = (180-T2)+T1;                                             //   

  if(D1 >= D2) minD = D2;                                       // 
  else         minD = D1;

  if(Z) return minD;                                            // 
  else  return -minD;                                           // 
}
//---------------------------------------------------------------------------
//   
void __fastcall TDetectorO::Work_Mov_Detector(TMov_Detector *Det)
{
  int        i,j,m;                                             // 
  int        Scet_Sr;                                           //  
  int        Osv_Tec,Osv_Old;                                   //   
  int        Kl_Sr_Det;                                         //  
  TPoint     DotT;                                              // 
  TColor     Color;                                             // 
  int        ColOldCond;                                        //  

  Kl_Sr_Det = 0;                                                //   
  for(i=1;i<=180;i++)                                           // 
  {
    Scet_Sr = 0;                                                //  
    for(j=1;j<=10;j++)                                          // 
    {
      DotT = Det->Arr_Det[i].Dots[j];                           // 
      Color = Rd_Dot(DotT.x,DotT.y);                            // 
      //  
      Osv_Tec = GetRValue(Color)+GetGValue(Color)+GetBValue(Color);
      Osv_Old = Det->Arr_Det[i].Old_Osv_Dots[j];                //  
      //     -  
      if(Osv_Tec > Osv_Old+80) Scet_Sr++;
      Det->Arr_Det[i].Old_Osv_Dots[j] = Osv_Tec;                //  
    }

    //   
    for(m=1;m<=19;m++) Det->Arr_Det[i].OldCond[m] = Det->Arr_Det[i].OldCond[m+1];
    if(Scet_Sr != 0) Det->Arr_Det[i].OldCond[20] = True;        //  
    else             Det->Arr_Det[i].OldCond[20] = False;       //  
    ColOldCond = 0;                                             //  
    //     
    for(m=1;m<=20;m++) if(Det->Arr_Det[i].OldCond[m]) ColOldCond++;

    if(ColOldCond >= 5) Det->Arr_Det[i].Blocked = True;         //  
    else                Det->Arr_Det[i].Blocked = False;

    //  ,        
    if((Scet_Sr != 0)&&(! Det->Arr_Det[i].Blocked)&&(Det->Old_Poz != i))
    {
      Det->Arr_Det[i].Bol = True;                               // 
      Det->Old_Poz = i;                                         //   
      Kl_Sr_Det++;                                              //  
    } else Det->Arr_Det[i].Bol = False;                         // 
  }

  for(i=1;i<=180;i++)                                           // 
  {
    //     -   
    if(IsSingle(Det,i)) Det->Arr_Det[i].Bol = False;
  }

  //     
  if(Kl_Sr_Det < 30)
  {
    if(IsItMovBol(Det,Det->Old_Poz))                            //   
    {
      Det->Faktor_Starta = True;                                // 
      for(i=1;i<=10;i++) Det->St_Koord[i] = 0;                  // 
    }
    else Det->Faktor_Starta = False;                            // 
  }
}
//---------------------------------------------------------------------------
//   double
double __fastcall TDetectorO::AbsD(double X)
{
  if(X >= 0) return X;                                          // 
  else       return -X;                                         //
}
//---------------------------------------------------------------------------
//  
double __fastcall TDetectorO::SQR(double X)
{
  return X*X;                                                   // 
}
//---------------------------------------------------------------------------
//     
TPointPolar __fastcall TDetectorO::DecartToPolar(TPoint A)
{
  TPointPolar  Result;                                          //

  //    - ..  
  A.x = A.x-Koleso.Center.x;                                    // X
  A.y = -(A.y-Koleso.Center.y);                                 // Y

  Result.Rad = (sqrt(SQR(abs(A.x))+SQR(abs(A.y))))+0.5;         //   

  Result.Ugol = 0;                                              // 
  if((A.x == 0)&&(A.y == 0)) Result.Ugol = -1;                  // 
  else                                                          //
  {
    if(A.x == 0)                                                //  
    {
      if(A.y > 0) Result.Ugol = 90;                             // 
      else        Result.Ugol = 270;                            // 
    }
    else                                                        // 
    {
      Result.Ugol = atan2(A.y,A.x);                             // 
      Result.Ugol = Result.Ugol*RAD;                            //  
      if(A.y < 0) Result.Ugol = (double)2*180+Result.Ugol;      // 3  4 
    }
  }
  return Result;                                                //
}
//---------------------------------------------------------------------------
//     
TPoint __fastcall TDetectorO::PolarToDecart(TPointPolar A)
{
  TPoint Result;                                                //

  Result.x = ((double)A.Rad*cos(A.Ugol/RAD))+0.5;               // X
  Result.y = ((double)A.Rad*sin(A.Ugol/RAD))+0.5;               // Y
  //   
  Result.x = Koleso.Center.x+Result.x;
  Result.y = Koleso.Center.y-Result.y;
  return Result;                                                //
}
//---------------------------------------------------------------------------
//   
void __fastcall TDetectorO::Build_Mov_Detector(TMov_Detector *Det, double Ecc, int Rot)
{
  int         i,j;                                              // 
  double      R1;                                               // 
  int         ARadius;                                          //    
  TPointPolar V_Dot;                                            // 

  for(i=1;i<=180;i++) Det->Arr_Det[i].Bol = False;              //   
  if(Ecc > 0.9) Ecc = 0.9;                                      // 
  if(Ecc < 0  ) Ecc = 0;

  R1 = Koleso.Sred_Rad*1.2;                                     //  
  for(i=1;i<=180;i++)                                           // 
  {
    //    
    ARadius = sqrt(SQR(R1)/(1-SQR(Ecc)*SQR(cos(((i*2)+Rot)/RAD)  )))+0.5;
    for(j=1;j<=10;j++)                                          //10   
    {
      V_Dot.Rad = ARadius+j*(Gl_Width/80);                      //
      V_Dot.Ugol = i*2;                                         //
      Det->Arr_Det[i].Dots[j] = PolarToDecart(V_Dot);           //
    }
  }
}
//---------------------------------------------------------------------------
//   
void __fastcall TDetectorO::Build_Bols_Area(double Ecc, int Rot)
{
  int    i;                                                     // 
  double R1;                                                    // 

  for(i=0;i<=360;i++)                                           //  
  {
    //  
    R1 = (double)Koleso.Sred_Rad*((double)Settings.MaxRBolAr/100);
    // 
    Bols_Area.Max_R[i] = (sqrt(SQR(R1)/(1-SQR(Ecc)*SQR(cos((i+Rot)/RAD)))))+0.5;
    //  -    
    Bols_Area.Min_R[i] = Bols_Area.Max_R[i]-(Koleso.Sred_Rad/3);
  }
}
//---------------------------------------------------------------------------
//  ,      
void __fastcall TDetectorO::Set_Parameter(Byte *Data, int Width, int Height, TF_Decoder_Rez Func)
{
  int i;                                                        //
  Rezult_Ev = Func;                                             // 
  Gl_Buf = Data;                                                //   
  if(Width < MaxAreaSz)  Gl_Width = Width;                      //      
  else                   Gl_Width = MaxAreaSz;
  if(Height < MaxAreaSz) Gl_Height = Height;
  else                   Gl_Height = MaxAreaSz;
  Init_OK = True;                                               // 
}
//---------------------------------------------------------------------------
//     
bool  __fastcall  TDetectorO::Find_Near_InSt(TBols_Stek Stek, TPoint Bol)
{
  int    i,j;                                                   // 
  int    Col_Sovp;                                              // 

  Col_Sovp = 0;                                                 //  
  //    -  , 
  for(j=1;j<=50;j++)
  {
    for(i=1;i<=10;i++) if(Rasst(Stek[j][i],Bol) <= 3) Col_Sovp++;
  }
  if(Col_Sovp >= 4) return True;                                //  
  else              return False;                               // 
}
//---------------------------------------------------------------------------
//   
void  __fastcall  TDetectorO::Filt_Koord_Shar(TObj_List *Tec_L)
{
  int    i;                                                     // 
  int    MinDist;                                               //   

  //  
  for(i=1;i<=Tec_L->Count_4Gran;i++)
  {
    //       
    if(Find_Near_InSt(Bols_Koord.Bols_St,Tec_L->Arr_4Gran[i].Centr_Mass)) Tec_L->Arr_4Gran[i].Actualn = False;
  }

  //    
  for(i=1;i<=10;i++) Bols_Koord.Bols_St[Bols_Koord.WrP_Fr][i] = Point(0,0);
  Bols_Koord.WrP_Bl = 1;
  //   ( )
  for(i=1;i<=Tec_L->Count_4Gran;i++)
  {
    if(Bols_Koord.WrP_Bl <= 10)                                 //  
    {
      //   
      Bols_Koord.Bols_St[Bols_Koord.WrP_Fr][Bols_Koord.WrP_Bl] = Tec_L->Arr_4Gran[i].Centr_Mass;
      //    
      Bols_Koord.WrP_Bl++;
    }
  }
  //    
  Bols_Koord.WrP_Fr++;
  if(Bols_Koord.WrP_Fr > 50) Bols_Koord.WrP_Fr = 1;             //

  //   ( )
  for(i=1;i<=Tec_L->Count_4Gran;i++)
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             // 
    {
      //   
      Tec_L->Arr_4Gran[i].DistToLastB = Rasst(Tec_L->LastPBol,Tec_L->Arr_4Gran[i].Centr_Mass);
    }
  }

  MinDist = 10000;                                              //   
  Tec_L->Ind_Bol = 0;                                           //   
  //   ( )
  for(i=1;i<=Tec_L->Count_4Gran;i++)
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             //  
    {
      if(MinDist >= Tec_L->Arr_4Gran[i].DistToLastB)            //      
      {
        MinDist = Tec_L->Arr_4Gran[i].DistToLastB;              // 
        Tec_L->Ind_Bol = i;                                     //  
      }
    }
  }
  //   -    
  if(Tec_L->Ind_Bol != 0) Tec_L->LastPBol = Tec_L->Arr_4Gran[Tec_L->Ind_Bol].Centr_Mass;
}
//---------------------------------------------------------------------------
//     
void  __fastcall  TDetectorO::Pr_Zalivka(void)
{
  int   i,j;                                                    // 
  int   Summa;                                                  //

  Summa = 0;                                                    // 
  for(i=0;i<Gl_Width;i++)                                       //    
  {
    for(j=0;j<Gl_Height;j++)
    {
      if(Rab_Arr[i][j] == 1) Summa++;                           //   - 
    }
  }

  //   
  Col_Porog.BW_Tec_Val = ((double)Summa/(Gl_Width*Gl_Height)*100)+0.5;
  //  /
  if(Col_Porog.BW_Tec_Val < Settings.Wh_Pers)   Col_Porog.BW_Max = Col_Porog.BW_Max-10;
  if(Col_Porog.BW_Tec_Val > Settings.Wh_Pers+5) Col_Porog.BW_Max = Col_Porog.BW_Max+10;
}
//---------------------------------------------------------------------------
//   
TColor  __fastcall  TDetectorO::Rd_CDot(Graphics::TBitmap *Bitm, int X, int  Y)
{
  Byte    *PLine;                                               //   
  int      Point;                                               // 

  //   
  if((X < Bitm->Width)&&(Y < Bitm->Height)&&(X >= 0)&&(Y >= 0))
  {
    PLine = (Byte*)Bitm->ScanLine[Y];                           //   
    Point = X*3;                                                // 
    // 
    return (TColor)RGB(PLine[Point+2],PLine[Point+1],PLine[Point]);
  } else return clBlack;                                        //  
}
//---------------------------------------------------------------------------
//    
void __fastcall  TDetectorO::Col_Filter(TF_Col F_Color, TColor Color)
{
  int  i,j;                                                     // 

  //    
  for(i=0;i<Gl_Width;i++)
  {
    for(j=0;j<Gl_Height;j++)
    {
      //   
      Rab_Arr[i][j] = F_Color(Point(i,j));
    }
  }
  Alone_Dot_Filter(3);                                          //  

  for(i=0;i<Gl_Width;i++)                                       // 
  {
    for(j=0;j<Gl_Height;j++)
    {
      if(Rab_Arr[i][j] == 1) Wr_Dot(i,j,Color);                 //    
      else                   Wr_Dot(i,j,clBlack);               //  
    }
  }
}
//---------------------------------------------------------------------------
//    
int __fastcall TDetectorO::Rasst_Dot_Line(TPoint X, TPoint A, TPoint B)
{
  double Verx,Niz,Rasst;                                        //  

  Verx = (A.y-B.y)*X.x+(B.x-A.x)*X.y+(A.x*B.y-B.x*A.y);         //
  Niz = sqrt(SQR(B.x-A.x)+SQR(B.y-A.y));                        //

  if(Niz != 0) return abs(Verx/Niz+0.5);                        //  
  else         return 0;                                        //  
}
//---------------------------------------------------------------------------
//     
void __fastcall TDetectorO::Ult_Center(TObj_List *Tec_L)
{
  int       i,j,m;                                              // 
  int       Min_R,Max_R;                                        //   R
  int       Var_R;                                              // R
  TPoint    Var_Point;                                          //  
  int       Rez_X,Rez_Y;                                        //   
  int       Delta_Centr[31][31];                                //    

  //          30  30 
  for(i=1;i<=30;i++)                                            // X
  {
    for(j=1;j<=30;j++)                                          // Y
    {
      Var_Point.x = Tec_L->Center.x-15+i;                       //  15   
      Var_Point.y = Tec_L->Center.y-15+j;
      Min_R = 100000000;                                        //
      Max_R = 0;
      for(m=1;m<=Tec_L->Count_4Gran;m++)                        //    
      {
        if(Tec_L->Arr_4Gran[m].Actualn)                         //   
        {
          // 
          Var_R = Rasst(Tec_L->Arr_4Gran[m].Centr_Mass,Var_Point);
          if(Min_R > Var_R) Min_R = Var_R;                      // 
          if(Max_R < Var_R) Max_R = Var_R;                      // 
        }
      }
      Delta_Centr[i][j] = abs(Max_R-Min_R);                     // 
    }
  }

  Rez_X = 0;                                                    //   
  Rez_Y = 0;
  Min_R = 100000000;                                            //
  //    
  for(i=1;i<=30;i++)                                            // X
  {
    for(j=1;j<=30;j++)                                          // Y
    {
      if(Min_R > Delta_Centr[i][j])                             // 
      {
        Min_R = Delta_Centr[i][j];                              // 
        Rez_X = i;                                              //
        Rez_Y = j;
      }
    }
  }

  Tec_L->Center.x = Tec_L->Center.x-15+Rez_X;                   //  
  Tec_L->Center.y = Tec_L->Center.y-15+Rez_Y;                   //     -9

  Sredn_Rad(Tec_L);                                             //      
}
//---------------------------------------------------------------------------
//    
TPoint __fastcall TDetectorO::Koleso_Centr_Buf(TPoint A)
{
  int     i;                                                    // 
  int     Sum_X,Sum_Y;                                          //
  TPoint  Result;                                               //

  if(Center_Bufer.Ind == 0)                                     // 
  {
    for(i=1;i<=70;i++) Center_Bufer.Dots[i] = A;                // 
  }

  Center_Bufer.Ind++;                                           // 
  if(Center_Bufer.Ind > 70) Center_Bufer.Ind = 1;               //
  Center_Bufer.Dots[Center_Bufer.Ind] = A;                      // 
  Sum_X = 0;                                                    // 
  Sum_Y = 0;
  for(i=1;i<=70;i++)                                            //   
  {
    Sum_X = Sum_X+Center_Bufer.Dots[i].x;                       //
    Sum_Y = Sum_Y+Center_Bufer.Dots[i].y;                       //
  }
  Result.x = Sum_X/70;                                          // 
  Result.y = Sum_Y/70;
  return Result;                                                // 
}
//---------------------------------------------------------------------------
//       ,    
//    
TPoint __fastcall TDetectorO::Vektor(TPoint A, TPoint B, int R)
{
  int     Dl_X,Dl_Y;                                            //
  int     Otr_Fakt;                                             //  
  TPoint  Result;                                               //

  Dl_X = B.x-A.x;                                               //  X
  Dl_Y = B.y-A.y;                                               //  Y
  Otr_Fakt = Rasst(A,B);                                        //  

  if(Otr_Fakt > 0)                                              //  
  {
    Result.x = ((double)A.x+R/Otr_Fakt*Dl_X)+0.5;               // ,   
    Result.y = ((double)A.y+R/Otr_Fakt*Dl_Y)+0.5;
  }
  return Result;                                                // 
}
//---------------------------------------------------------------------------
//  
int __fastcall TDetectorO::Rasst(TPoint A, TPoint B)
{
  return sqrt(SQR(abs(B.x-A.x))+SQR(abs(B.y-A.y)))+0.5;         //  
}
//---------------------------------------------------------------------------
// 
void  __fastcall  TDetectorO::Gr_Center(T4Gran *Gr)
{
  Gr->Centr_Mass.x = (Gr->Grani.Right +Gr->Grani.Left) / 2;
  Gr->Centr_Mass.y = (Gr->Grani.Bottom+Gr->Grani.Top ) / 2;
}
//---------------------------------------------------------------------------
// 
void  __fastcall  TDetectorO::Gr_Area(T4Gran *Gr)
{
  // 
  Gr->SzArea = (Gr->Grani.Right-Gr->Grani.Left)*(Gr->Grani.Bottom-Gr->Grani.Top);
}
//---------------------------------------------------------------------------
// 
void  __fastcall  TDetectorO::Wr_Label(int X, int Y, String Txt, TColor Color)
{
  int    i,j;                                                   // 
  int    Width,Height;                                          //   

  Text_Im->Canvas->Lock();
  Txt = Txt+" ";                                                // 
  Text_Im->Canvas->Brush->Color = Color;                        // 
  Text_Im->Canvas->Font->Name = "Arial";                        //
  Text_Im->Canvas->Font->Size = 6;                              //
  Text_Im->Canvas->Font->Color = clBlack;                       // 
  Width = Text_Im->Canvas->TextWidth(Txt);                      //   
  Height = Text_Im->Canvas->TextHeight(Txt);
  Text_Im->Canvas->TextOut(1,1,Txt);                            // 
  Text_Im->Canvas->Unlock();

  for(i=1;i<=Width;i++)                                         // 
  {
    for(j=1;j<=Height;j++)                                      // 
    {
      Wr_Dot(X+i,Y+j,Rd_CDot(Text_Im,i,j));                     //  
    }
  }
}
//---------------------------------------------------------------------------
//     
bool  __fastcall  TDetectorO::Dot_In_All_4Gr(TObj_List *ObjL, TPoint Dot)
{
  int  i;                                                       // 
  bool Result;                                                  //

  Result = True;                                                //     
  for(i=1;i<=ObjL->Count_4Gran;i++)                             // 
  {
    //    
    if(Dot_In_4Gr(ObjL->Arr_4Gran[i], Dot)) Result = False;
  }
  return Result;                                                //
}
//---------------------------------------------------------------------------
//    
bool  __fastcall  TDetectorO::Dot_In_4Gr(T4Gran Gr, TPoint Dot)
{
  bool Result = False;                                          //   

  if((Dot.x >= Gr.Grani.Left)&&(Dot.x <= Gr.Grani.Right))       //  X
  {
    //  Y
    if((Dot.y >= Gr.Grani.Top)&&(Dot.y <= Gr.Grani.Bottom)) Result = True;
  }
  return Result;                                                //
}
//---------------------------------------------------------------------------
// 
void  __fastcall  TDetectorO::Create_4Gran(TObj_List *ObjL)
{
  int  Otstup;                                                  //

  if(ObjL->Count_4Gran < maxSList)                              //
  {
    ObjL->Count_4Gran++;                                        // 
    Otstup = 2;                                                 //
    //""  
    K_4G.Var_Rect.Left   = K_4G.Var_Rect.Left-Otstup;
    K_4G.Var_Rect.Right  = K_4G.Var_Rect.Right+Otstup;
    K_4G.Var_Rect.Top    = K_4G.Var_Rect.Top-Otstup;
    K_4G.Var_Rect.Bottom = K_4G.Var_Rect.Bottom+Otstup;
    //  
    ObjL->Arr_4Gran[ObjL->Count_4Gran].Grani   = K_4G.Var_Rect;
    // 
    Gr_Center(&ObjL->Arr_4Gran[ObjL->Count_4Gran]);
    // 
    Gr_Area(&ObjL->Arr_4Gran[ObjL->Count_4Gran]);

    ObjL->Arr_4Gran[ObjL->Count_4Gran].Ord_Nomer = 0;           //   
    ObjL->Arr_4Gran[ObjL->Count_4Gran].Real_Nomer = 0;          // 

    ObjL->Arr_4Gran[ObjL->Count_4Gran].Metka = K_4G.T_Metka;    //  
    ObjL->Arr_4Gran[ObjL->Count_4Gran].Actualn = True;          // 

    //   
    if(ObjL->Arr_4Gran[ObjL->Count_4Gran].SzArea < 250) ObjL->Count_4Gran--;
  }
}
//---------------------------------------------------------------------------
// 
void  __fastcall  TDetectorO::Wr_Dot(int X, int Y, TColor Color)
{
  int  Sm;                                                      //  

  if((X > 0)&&(X < Gl_Width))                                   //
  {
    if((Y > 0)&&(Y < Gl_Height))                                //
    {
      Y = Gl_Height-Y;                                          //  
      Sm = Y*3*Gl_Width+X*3;                                    //  
      Gl_Buf[Sm+0] = GetBValue(Color);                          //3   
      Gl_Buf[Sm+1] = GetGValue(Color);
      Gl_Buf[Sm+2] = GetRValue(Color);
    }
  }
}
//---------------------------------------------------------------------------
// 
TColor  __fastcall  TDetectorO::Rd_Dot(int X, int Y)
{
  int  Sm;                                                      //  

  if((X > 0)&&(X < Gl_Width))                                   //
  {
    if((Y > 0)&&(Y < Gl_Height))                                //
    {
      Y = Gl_Height-Y;                                          //  
      Sm = Y*3*Gl_Width+X*3;                                    //  
      // 
      return (TColor)RGB(Gl_Buf[Sm+2],Gl_Buf[Sm+1],Gl_Buf[Sm+0]);
    } else return clBlack;                                      //  
  } else return clBlack;                                        //  
}
//---------------------------------------------------------------------------
// 
void  __fastcall  TDetectorO::Wr_Line(int X1, int Y1, int X2, int Y2, TColor Color)
{
  double    Shag_X,Shag_Y;                                      //  
  int       Dl_X,Dl_Y;                                          //  
  int       i;                                                  // 
  int       Kol_Dot;                                            // 
  double    Koord_X,Koord_Y;                                    // 

  Dl_X = abs(X2-X1);                                            //  X
  Dl_Y = abs(Y2-Y1);                                            //  Y
  //     
  if(Dl_X >= Dl_Y) Kol_Dot = Dl_X;
  else             Kol_Dot = Dl_Y;

  if(Kol_Dot > 0)                                               //   
  {
    Shag_X = ((double)X2-X1)/Kol_Dot;                           //  
    Shag_Y = ((double)Y2-Y1)/Kol_Dot;

    Koord_X = X1;                                               // 
    Koord_Y = Y1;                                               // 
    for(i=0;i<=Kol_Dot;i++)                                     //   
    {
      Wr_Dot(Koord_X+0.5,Koord_Y+0.5,Color);                    // 
      Koord_X += Shag_X;                                        //  X
      Koord_Y += Shag_Y;                                        //  Y
    }
  }
}
//---------------------------------------------------------------------------
// 
void  __fastcall  TDetectorO::Wr_Rect(int X, int Y, int W, int H, TColor Color)
{
  Wr_Line(X  ,Y  ,X+W,Y  ,Color);                               // 
  Wr_Line(X+W,Y  ,X+W,Y+H,Color);
  Wr_Line(X+W,Y+H,X  ,Y+H,Color);
  Wr_Line(X  ,Y+H,X  ,Y  ,Color);
}
//---------------------------------------------------------------------------
//    
bool  __fastcall  TDetectorO::Dot_Color_OK(TPoint Tec_Dot)
{
  if((Tec_Dot.x >= 0)&&(Tec_Dot.x <= Gl_Width))                 //  X
  {
    if((Tec_Dot.y >= 0)&&(Tec_Dot.y <= Gl_Height))              //  Y
    {
      if(Rab_Arr[Tec_Dot.x][Tec_Dot.y] > 0) return True;        //  
    }
  }
  return False;                                                 //   -  
}
//---------------------------------------------------------------------------
//  
void  __fastcall  TDetectorO::Point_Gran(int X, int Y)
{
  // 
  if(X > K_4G.Var_Rect.Right ) K_4G.Var_Rect.Right  = X;
  if(X < K_4G.Var_Rect.Left  ) K_4G.Var_Rect.Left   = X;
  if(Y > K_4G.Var_Rect.Bottom) K_4G.Var_Rect.Bottom = Y;
  if(Y < K_4G.Var_Rect.Top   ) K_4G.Var_Rect.Top    = Y;
}
//---------------------------------------------------------------------------
//  
void  __fastcall  TDetectorO::St_PUSH(TPoint Dot)
{
  if(StP.St_Ind < 5)                                            // 
  {
    StP.St_Ind++;                                               // 
    StP.St_Arr[StP.St_Ind] = Dot;                               //
  }
}
//---------------------------------------------------------------------------
//  
bool  __fastcall  TDetectorO::St_POP(TPoint *Dot)
{
  if(StP.St_Ind > 0)                                            //   
  {
    *Dot = StP.St_Arr[StP.St_Ind];                              //
    StP.St_Ind--;                                               // 
    return True;                                                // 
  } else return False;                                          // 
}
//---------------------------------------------------------------------------
//        
bool  __fastcall  TDetectorO::Sosedi_OK(TPoint Dot, int Kol_S)
{
  int   i,j;                                                    // 
  int   F_R;                                                    //  
  int   Scetch;                                                 // 

  F_R = 4;                                                      //  
  Scetch = 0;                                                   // 
  for(i=Dot.x-F_R;i<=Dot.x+F_R;i++)                             //  X
  {
    for(j=Dot.y-F_R;j<=Dot.y+F_R;j++)                           //  Y
    {
      if(Dot_Color_OK(Point(i,j)))                              //  
      {
        Scetch++;                                               //  
        if(Scetch >= Kol_S) return True;                        //     
      }
    }
  }
  return False;                                                 //  
}
//---------------------------------------------------------------------------
//       
void  __fastcall  TDetectorO::Area_4Gr(TObj_List *Tec_L, TPoint Start)
{
  TPoint   Var_Dot;                                             //  
  TPoint   Mov_Dot;                                             //   
  int      Left_Kr;                                             //   
  int      K_Sosedei;                                           //   
  bool     Flag_L_GR;                                           //   

  K_Sosedei = 3;                                                //   
  St_PUSH(Start);                                               //    
  Left_Kr = Start.x;                                            //   

  //" "  
  K_4G.Var_Rect.Left   = Gl_Width;
  K_4G.Var_Rect.Right  = 0;
  K_4G.Var_Rect.Top    = Gl_Height;
  K_4G.Var_Rect.Bottom = 0;

  while(St_POP(&Var_Dot))                                       //    
  {
    Flag_L_GR = False;                                          //   
    Mov_Dot = Var_Dot;                                          //    
    //    
    if(Dot_Color_OK(Mov_Dot))
    {
      Point_Gran(Mov_Dot.x,Mov_Dot.y);                          //  
    }

    while(Sosedi_OK(Point(Mov_Dot.x-1,Mov_Dot.y),K_Sosedei))    // 
    {
      Mov_Dot.x--;                                              //
      //    
      if(Dot_Color_OK(Mov_Dot))
      {
        Point_Gran(Mov_Dot.x,Mov_Dot.y);                        //  
        Left_Kr = Mov_Dot.x;                                    //   
        Flag_L_GR = True;                                       // 
      }
    }

    Mov_Dot = Var_Dot;                                          //    
    while(Sosedi_OK(Point(Mov_Dot.x+1,Mov_Dot.y),K_Sosedei))    // 
    {
      Mov_Dot.x++;                                              //
      //    
      if(Dot_Color_OK(Mov_Dot))
      {
        Point_Gran(Mov_Dot.x,Mov_Dot.y);                        //  
        if(Flag_L_GR == False)                                  //    
        {
          Left_Kr = Mov_Dot.x;                                  //   
          Flag_L_GR = True;                                     //     
        }
      }
    }

    Mov_Dot.x = Left_Kr;                                        //    
    Mov_Dot.y = Var_Dot.y+1;                                    //  
    //      - 
    if(Sosedi_OK(Mov_Dot,K_Sosedei)) St_PUSH(Mov_Dot);
  }
  Create_4Gran(Tec_L);                                          // 
}
//---------------------------------------------------------------------------
//   
Byte  __fastcall  TDetectorO::Color_Green(TPoint Tec_Dot)
{
  TColor   Color;                                               // 
  Byte     RV,GV,BV;                                            //

  Color = Rd_Dot(Tec_Dot.x,Tec_Dot.y);                          // 
  RV = GetRValue(Color);                                        // 
  GV = GetGValue(Color);
  BV = GetBValue(Color);

  if(GV > Col_Porog.Green_Max)                                  //  
  {
    //    
    if((GV > RV+Col_Porog.Green_R)&&(GV >= BV+Col_Porog.Green_B)) return 1;
  }
  return 0;                                                     // 
}
//---------------------------------------------------------------------------
//   
Byte  __fastcall  TDetectorO::Color_Red(TPoint Tec_Dot)
{
  Byte   RV,GV,BV;                                              //
  TColor Color;                                                 // 

  Color = Rd_Dot(Tec_Dot.x,Tec_Dot.y);                          // 
  RV = GetRValue(Color);                                        // 
  GV = GetGValue(Color);
  BV = GetBValue(Color);

  if(RV > Col_Porog.Red_Max)                                    //  
  {
    //    
    if((RV > GV+Col_Porog.Red_G)&&(RV > BV+Col_Porog.Red_B)) return 1;
  }
  return 0;                                                     // 
}
//---------------------------------------------------------------------------
//   
Byte  __fastcall  TDetectorO::Color_White(TPoint Tec_Dot)
{
  TColor  Color;                                                // 
  Byte    BW;                                                   // / 
  Byte    Dlt1,Dlt2,Dlt3;                                       //  

  Color = Rd_Dot(Tec_Dot.x,Tec_Dot.y);                          // 
  // / 
  BW = (GetRValue(Color)+GetGValue(Color)+GetBValue(Color)) / 3;

  if(BW > Col_Porog.BW_Max)                                     //   
  {
    Dlt1 = abs(BW-GetRValue(Color));                            //  
    Dlt2 = abs(BW-GetGValue(Color));
    Dlt3 = abs(BW-GetBValue(Color));
    //   
    if((Dlt1 < Settings.ClWhDelt)&&(Dlt2 < Settings.ClWhDelt)&&(Dlt3 < Settings.ClWhDelt)) return 1;                                            //  
    else return 0;                                              //
  }
  else return 0;                                                //
}
//---------------------------------------------------------------------------
//    
Byte  __fastcall  TDetectorO::Alt_Color_White(TPoint Tec_Dot)
{
  TColor  Color;                                                // 

  Color = Rd_Dot(Tec_Dot.x,Tec_Dot.y);                          // 
  //   
  if((GetRValue(Color) > Settings.Alt_Level) && (GetGValue(Color) > Settings.Alt_Level) && (GetBValue(Color) > Settings.Alt_Level)) return 1;
  else return 0;                                                //
}
//---------------------------------------------------------------------------
//  
void __fastcall  TDetectorO::Alone_Dot_Filter(int K_Faktor)
{
  int  i,j;                                                     // 
  int  Summa;                                                   //  

  for(i=1;i<=Gl_Width-2;i++)                                    //  X
  {
    for(j=1;j<=Gl_Height-2;j++)                                 //  Y
    {
      Summa = 0;                                                //  
      if(Rab_Arr[i][j] == 1)                                    //   
      {
        if(Rab_Arr[i-1][j-1] == 1) Summa++;                     // 
        if(Rab_Arr[i  ][j-1] == 1) Summa++;
        if(Rab_Arr[i+1][j-1] == 1) Summa++;
        if(Rab_Arr[i+1][j  ] == 1) Summa++;
        if(Rab_Arr[i-1][j  ] == 1) Summa++;
        if(Rab_Arr[i-1][j+1] == 1) Summa++;
        if(Rab_Arr[i  ][j+1] == 1) Summa++;
        if(Rab_Arr[i+1][j+1] == 1) Summa++;

        if(Summa < K_Faktor) Rab_Arr[i][j] = 0;                 //       
      }
    }
  }
}
//---------------------------------------------------------------------------
//        
void __fastcall  TDetectorO::Matrix_Bol(TObj_List *Tec_L, TPoint St_Point)
{
  int      i,j;                                                 // 
  Byte     APix;                                                //  
  int      Var_X,Var_Y;                                         //   
  int      Metrix_1_Bol;                                        //    
  int      Metrix_2_Bol;                                        //    
  int      Metrix_3_Bol;                                        //    
  TRect    V_Rect;                                              // 
  int      Otstup;                                              // 
  int      Korr_Poz;                                            //  
  int      Razm_Matr;                                           //  
  int      Matrix_ID;                                           //  

  Matrix_ID = 0;                                                //  
  Metrix_1_Bol = 0;                                             //    
  Metrix_2_Bol = 0;                                             //    
  Metrix_3_Bol = 0;                                             //    
  //  
  for(i=1;i<=13;i++)
  {
    for(j=1;j<=13;j++)
    {
      Var_X = St_Point.x-6+i;                                   // 
      Var_Y = St_Point.y-6+j;
      //    
      if((Var_X>0)&&(Var_X<Gl_Width)&&(Var_Y>0)&&(Var_Y<Gl_Height))
      {
        //-------------
        if((i<=9)&&(j<=9))                                      //    
        {
          APix = Bol_1_Matr[i][j];                              //  
          if(APix > 1)                                          // 
          {
            APix = APix-2;                                      //  0/1
            //   - 
            if(APix == Rab_Arr[Var_X][Var_Y]) Metrix_1_Bol++;
            else Metrix_1_Bol = Metrix_1_Bol-20;                //  - 
          }
          else                                                  // 
          {
            //   - 
            if(APix == Rab_Arr[Var_X][Var_Y]) Metrix_1_Bol++;
          }
        }
        //-------------
        if((i<=11)&&(j<=11))                                    //    
        {
          APix = Bol_2_Matr[i][j];                              //  
          if(APix > 1)                                          // 
          {
            APix = APix-2;                                      //  0/1
            //   - 
            if(APix == Rab_Arr[Var_X][Var_Y]) Metrix_2_Bol++;
            else Metrix_2_Bol = Metrix_2_Bol-30;                //  - 
          }
          else                                                  // 
          {
            //   - 
            if(APix == Rab_Arr[Var_X][Var_Y]) Metrix_2_Bol++;
          }
        }
        //-------------
        APix = Bol_3_Matr[i][j];                                //  
        if(APix > 1)                                            // 
        {
          APix = APix-2;                                        //  0/1
          //   - 
          if(APix == Rab_Arr[Var_X][Var_Y]) Metrix_3_Bol++;
          else Metrix_3_Bol = Metrix_3_Bol-40;                  //  - 
        }
        else                                                    // 
        {
          //   - 
          if(APix == Rab_Arr[Var_X][Var_Y]) Metrix_3_Bol++;
        }
      }
    }
  }

  Korr_Poz = 0;                                                 //     
  Razm_Matr = 0;                                                //  

  // ""   -    
  if(Metrix_1_Bol > Settings.ML_1)                              //70
  {
    Matrix_ID = 1;                                              //  
    Korr_Poz = 4;                                               //  
    Razm_Matr = 9;                                              //  
  }
  else
  {
    // ""   -    
    if(Metrix_2_Bol > Settings.ML_2)                            //105
    {
      Matrix_ID = 2;                                            //  
      Korr_Poz = 5;                                             //  
      Razm_Matr = 11;                                           //  
    }
    else                                                        //  
    {
      // ""  
      if(Metrix_3_Bol > Settings.ML_3)                          //146
      {
        Matrix_ID = 3;                                          //  
        Korr_Poz = 6;                                           //  
        Razm_Matr = 13;                                         //  
      }
    }
  }

  if(Korr_Poz > 0)                                              //  
  {
    St_Point.x = St_Point.x-Korr_Poz;                           //  
    St_Point.y = St_Point.y-Korr_Poz;

    if(Tec_L->Count_4Gran < maxSList)                           //
    {
      Tec_L->Count_4Gran++;                                     // 
      Otstup = 3;                                               //
      //""  
      V_Rect.Left   = St_Point.x-Otstup;
      V_Rect.Right  = St_Point.x+Razm_Matr+Otstup;
      V_Rect.Top    = St_Point.y-Otstup;
      V_Rect.Bottom = St_Point.y+Razm_Matr+Otstup;
      //  
      Tec_L->Arr_4Gran[Tec_L->Count_4Gran].Grani = V_Rect;
      //  
      Tec_L->Arr_4Gran[Tec_L->Count_4Gran].Matrix_ID = Matrix_ID;
      // 
      Gr_Center(&Tec_L->Arr_4Gran[Tec_L->Count_4Gran]);
      // 
      Gr_Area(&Tec_L->Arr_4Gran[Tec_L->Count_4Gran]);
      // 
      Tec_L->Arr_4Gran[Tec_L->Count_4Gran].Actualn = True;
    }
  }
}
//---------------------------------------------------------------------------
//    
void __fastcall  TDetectorO::Scan_Shar(TObj_List *Tec_L, TF_Col F_Color)
{
  TPoint       Tochka;                                          // 
  int          i,j;                                             // 
  TPointPolar  PPoint;                                          // 
  int          UgolIndex;                                       //    

  Settings.ML_1 = (double)81/100*Settings.MatrixLev+0.5;        //    
  Settings.ML_2 = (double)121/100*Settings.MatrixLev+0.5;
  Settings.ML_3 = (double)169/100*Settings.MatrixLev+0.5;

  //    
  for(i=0;i<Gl_Width;i++)
  {
    for(j=0;j<Gl_Height;j++)
    {
      //   
      Rab_Arr[i][j] = F_Color(Point(i,j));
    }
  }
  Alone_Dot_Filter(3);                                          //  
  //   
  if(Settings.Alt_White == 0) Pr_Zalivka();                     //     

  Tochka.y = 0;                                                 //   
  while(Tochka.y <= Gl_Height)                                  // 
  {
    Tochka.x = 0;                                               //   
    while(Tochka.x <= Gl_Width)                                 // 
    {
      if(Dot_Color_OK(Tochka))                                  //    
      {
        PPoint = DecartToPolar(Tochka);                         // 
        UgolIndex = PPoint.Ugol+0.5;                            //    
        if(UgolIndex <= 360)                                    //  
        {
          //   
          if((PPoint.Rad > Bols_Area.Min_R[UgolIndex])&&(PPoint.Rad < Bols_Area.Max_R[UgolIndex]))
          {
            if(Dot_In_All_4Gr(Tec_L,Tochka))                    //      
            {
              //        
              Matrix_Bol(Tec_L,Tochka);
            }
          }
        }
      }
      Tochka.x = Tochka.x+1;                                    //  
    }
    Tochka.y = Tochka.y+1;                                      //  
  }
}
//---------------------------------------------------------------------------
//       
void __fastcall  TDetectorO::Scan(TObj_List *Tec_L, TF_Col F_Color, Char Metka)
{
  TPoint Tochka;                                                // 
  int    i,j;                                                   // 

  //    
  for(i=0;i<Gl_Width;i++)
  {
    for(j=0;j<Gl_Height;j++)
    {
      //   
      Rab_Arr[i][j] = F_Color(Point(i,j));
    }
  }
  Alone_Dot_Filter(1);                                          //  
  K_4G.T_Metka = Metka;                                         //    

  Tochka.y = 0;                                                 //   
  while(Tochka.y <= Gl_Height)                                  // 
  {
    Tochka.x = 0;                                               //   
    while(Tochka.x <= Gl_Width)                                 // 
    {
      if(Dot_Color_OK(Tochka))                                  //    
      {
        if(Dot_In_All_4Gr(Tec_L,Tochka))                        //     
        {
          //       
          Area_4Gr(Tec_L,Tochka);
        }
      }
      Tochka.x = Tochka.x+2;                                    //  
    }
    Tochka.y = Tochka.y+2;                                      //  
  }
}
//---------------------------------------------------------------------------
//      
void __fastcall  TDetectorO::Sredn_Rad(TObj_List *Tec_L)
{
  int     i;                                                    // 
  int     Col_Obj;                                              //  

  Tec_L->Sred_Rad = 0;                                          //   
  Col_Obj = 0;                                                  //  
  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             //   
    {
      Col_Obj++;                                                // 
      //  
      Tec_L->Arr_4Gran[i].Rasst_Center = Rasst(Tec_L->Arr_4Gran[i].Centr_Mass,Tec_L->Center);
      //
      Tec_L->Sred_Rad = Tec_L->Sred_Rad+Tec_L->Arr_4Gran[i].Rasst_Center;
    }
  }
  //   
  if(Col_Obj > 0) Tec_L->Sred_Rad = Tec_L->Sred_Rad / Col_Obj;
}
//---------------------------------------------------------------------------
//   
void __fastcall  TDetectorO::Detect_Center(TObj_List *Tec_L)
{
  int    i;                                                     // 
  int    Col_Obj;                                               //  
  int    Sum_X,Sum_Y;                                           //

  //         
  if(Tec_L->Count_4Gran >= 10)                                  //   
  {
    Sum_X = 0;                                                  // 
    Sum_Y = 0;
    Col_Obj = 0;                                                //  
    for(i=1;i<=Tec_L->Count_4Gran;i++)                          //    
    {
      if(Tec_L->Arr_4Gran[i].Actualn)                           //   
      {
        Col_Obj++;                                              // 
        Sum_X = Sum_X+Tec_L->Arr_4Gran[i].Centr_Mass.x;         //  X
        Sum_Y = Sum_Y+Tec_L->Arr_4Gran[i].Centr_Mass.y;         //  Y
      }
    }
    if(Col_Obj > 0)                                             //  
    {
      Tec_L->Center.x = Sum_X / Col_Obj;                        // 
      Tec_L->Center.y = Sum_Y / Col_Obj;
    }

    //  
    for(i=1;i<=Tec_L->Count_4Gran;i++)                          //    
    {
      if(Tec_L->Arr_4Gran[i].Actualn)                           //   
      {
        //       ,    
        //       
        Tec_L->Arr_4Gran[i].Var_Point = Vektor(Tec_L->Arr_4Gran[i].Centr_Mass,Tec_L->Center,(double)Gl_Width*0.6+0.5);
      }
    }

    //      
    Sum_X = 0;                                                  // 
    Sum_Y = 0;
    for(i=1;i<=Tec_L->Count_4Gran;i++)                          //    
    {
      if(Tec_L->Arr_4Gran[i].Actualn)                           //   
      {
        Sum_X = Sum_X+Tec_L->Arr_4Gran[i].Var_Point.x;          //  X
        Sum_Y = Sum_Y+Tec_L->Arr_4Gran[i].Var_Point.y;          //  Y
      }
    }
    if(Col_Obj > 0)                                             //  
    {
      Tec_L->Center.x = Sum_X / Col_Obj;                        // 
      Tec_L->Center.y = Sum_Y / Col_Obj;
    }

    Sredn_Rad(Tec_L);                                           //      
  }
  else                                                          //   
  {
    Tec_L->Center.x = 0;                                        // 
    Tec_L->Center.y = 0;
    Tec_L->Sred_Rad = 0;                                        //  
  }
}
//---------------------------------------------------------------------------
//  
void __fastcall  TDetectorO::Oforml_Bol(T4Gran Bol, TColor Color)
{
  int    M_X,M_Y;                                               // 
  TRect  R;                                                     // 

  M_X = Bol.Centr_Mass.x;                                       // 
  M_Y = Bol.Centr_Mass.y;
  Wr_Line(M_X-5,M_Y,M_X+5,M_Y,clRed);
  Wr_Line(M_X,M_Y-5,M_X,M_Y+5,clRed);

  R = Bol.Grani;                                                //  
  // 
  Wr_Rect(R.Left,R.Top,R.Right-R.Left,R.Bottom-R.Top,Color);
  //
  Wr_Line(R.Left,R.Top,R.Right,R.Bottom,Color);
  Wr_Line(R.Left,R.Bottom,R.Right,R.Top,Color);

  //  
  Wr_Label(M_X+1,M_Y+1,IntToStr(Bol.Matrix_ID),clLime);
}
//---------------------------------------------------------------------------
//   
void __fastcall  TDetectorO::Oformlenie(void)
{
  int         i;                                                // 
  int         M_X,M_Y;                                          // 
  TRect       R;                                                // 
  TColor      Col_C;                                            // 
  TColor      Col_D;                                            //  
  TPoint      P1,P2;                                            //
  TPointPolar PPoint;                                           // 

  for(i=1;i<=Koleso.Count_4Gran;i++)                            // 
  {
    if(Koleso.Arr_4Gran[i].Actualn)                             //   
    {
      Col_C = clBlue;                                           //    
      if(Koleso.Arr_4Gran[i].Metka == 'G') Col_C = clGreen;     // 
      if(Koleso.Arr_4Gran[i].Metka == 'R') Col_C = clRed;       // 

      M_X = Koleso.Arr_4Gran[i].Centr_Mass.x;                   // 
      M_Y = Koleso.Arr_4Gran[i].Centr_Mass.y;
      Wr_Line(M_X-5,M_Y,M_X+5,M_Y,Col_C);
      Wr_Line(M_X,M_Y-5,M_X,M_Y+5,Col_C);

      if(Koleso.Arr_4Gran[i].Metka != 'V')                      //   
      {
        R = Koleso.Arr_4Gran[i].Grani;                          //  
        // 
        Wr_Rect(R.Left,R.Top,R.Right-R.Left,R.Bottom-R.Top,clBlue);
      }

      // 
      Wr_Label(M_X+2,M_Y+2,IntToStr(Koleso.Arr_4Gran[i].Real_Nomer),Col_C);
    }
  }

  M_X = Koleso.Center.x;                                        // 
  M_Y = Koleso.Center.y;
  Wr_Line(M_X-5,M_Y,M_X+5,M_Y,clYellow);                        //   
  Wr_Line(M_X,M_Y-5,M_X,M_Y+5,clYellow);

  if(Koleso.Ugl_Speed_OK) Col_C = clLime;                       //    
  else                    Col_C = clAqua;                       //  

  for(i=1;i<=Bols.Count_4Gran;i++)                              // 
  {
    if(Bols.Arr_4Gran[i].Actualn)                               //   
    {
      Oforml_Bol(Bols.Arr_4Gran[i],clLime);                     //  
    }
    else Oforml_Bol(Bols.Arr_4Gran[i],clWhite);                 //  
  }

  //  
  for(i=1;i<=180;i++)                                           //  180
  {
    if(Mov_Detector.Arr_Det[i].Bol) Col_D = clRed;              //    -  
    else                                                        //  
    {
      if(Mov_Detector.Arr_Det[i].Blocked) Col_D = clWhite;      // 
      else                                Col_D = clGreen;      // 
    }
    P1 = Mov_Detector.Arr_Det[i].Dots[1 ];                      // 
    P2 = Mov_Detector.Arr_Det[i].Dots[10];
    //    -  ,   - 
    Wr_Line(P1.x,P1.y,P2.x,P2.y,Col_D);                         // 
  }

  //    
  i = 0;                                                        //  0 
  while(i <= 360)                                               //  
  {
    PPoint.Ugol = i;                                            //    
    PPoint.Rad = Bols_Area.Min_R[i];                            // 
    P1 = PolarToDecart(PPoint);                                 //    
    Wr_Dot(P1.x,P1.y,clYellow);                                 // 
    PPoint.Rad = Bols_Area.Max_R[i];                            // 
    P1 = PolarToDecart(PPoint);                                 //    
    Wr_Dot(P1.x,P1.y,clYellow);                                 // 

    i += 2;                                                     //   
  }

  //  
  Wr_Label(10,10,"Sp: "+IntToStr((int)(Will_Speed+0.5)),Col_C);
  // 
  Wr_Label(5,Gl_Height-20,"RG: "+IntToStr(Col_Porog.Red_G),clLime);
  Wr_Label(5,Gl_Height-10,"RB: "+IntToStr(Col_Porog.Red_B),clLime);
  Wr_Label(40,Gl_Height-20,"GR: "+IntToStr(Col_Porog.Green_R),clLime);
  Wr_Label(40,Gl_Height-10,"GB: "+IntToStr(Col_Porog.Green_B),clLime);

//  for(i=1;i<=50;i++)                                            // 
//  {
//    if(TestP[i][1].x != 0)                                      //  
//    {
//      //  
//      Wr_Line(TestP[i][1].x,TestP[i][1].y,TestP[i][2].x,TestP[i][2].y,clYellow);
//    }
//  }
}
//---------------------------------------------------------------------------
//    
void __fastcall  TDetectorO::Filter_Obj_Rast(TObj_List *Tec_L)
{
  int i;                                                        // 

  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             //   
    {
      //30-     
      if((Tec_L->Arr_4Gran[i].Rasst_Center < ((float)Tec_L->Sred_Rad*0.7))||(Tec_L->Arr_4Gran[i].Rasst_Center > ((float)Tec_L->Sred_Rad*1.2)))
      {
        //  
        Tec_L->Arr_4Gran[i].Actualn = False;
      }
    }
  }
}
//---------------------------------------------------------------------------
//   
void __fastcall  TDetectorO::Filter_Area(TObj_List *Tec_L)
{
  int i;                                                        // 

  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    //   
    if(Tec_L->Arr_4Gran[i].SzArea > 3000) Tec_L->Arr_4Gran[i].Actualn = False;
  }
}
//---------------------------------------------------------------------------
//     
void __fastcall  TDetectorO::SelMaxGreen(TObj_List *Tec_L)
{
  int    i;                                                     // 
  int    ASect;                                                 //  
  int    MaxSize;                                               // 

  ASect = -1;                                                   //  
  MaxSize = -1;                                                 // 
  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             //   
    {
      if(Tec_L->Arr_4Gran[i].Metka == 'G')                      //  
      {
        if(Tec_L->Arr_4Gran[i].SzArea > MaxSize)                //    
        {
          ASect = i;                                            // 
          MaxSize = Tec_L->Arr_4Gran[i].SzArea;                 // 
        }
        Tec_L->Arr_4Gran[i].Actualn = False;                    //    
      }
    }
  }
  //    -  
  if(ASect >= 1) Tec_L->Arr_4Gran[ASect].Actualn = True;
}
//---------------------------------------------------------------------------
//    
bool __fastcall  TDetectorO::Green_OK(TObj_List *Tec_L)
{
  int   i;                                                      // 
  int   Sc;                                                     // 

  Sc = 0;                                                       // 
  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             //   
    {
      //   -   
      if(Tec_L->Arr_4Gran[i].Metka == 'G') Sc++;
    }
  }

  if(Sc == 1) return True;                                      //   
  else        return 0;                                         // 
}
//---------------------------------------------------------------------------
//   
int __fastcall  TDetectorO::Find_Green(TObj_List *Tec_L)
{
  int i;                                                        // 
  int Result;                                                   //

  Result = 1;                                                   //   
  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             //   
    {
      //   -   
      if(Tec_L->Arr_4Gran[i].Metka == 'G') Result = i;
    }
  }
  return Result;                                                //
}
//---------------------------------------------------------------------------
//     
bool __fastcall  TDetectorO::Find_Sektor(TPointPolar S, int *Ind)
{
  int           i;                                              // 
  TPointPolar   V_Point;                                        // 
  double        Delt_Angl;                                      // 

  for(i=1;i<=Koleso.Count_4Gran;i++)                            //    
  {
    if(Koleso.Arr_4Gran[i].Actualn)                             //   
    {
      V_Point = DecartToPolar(Koleso.Arr_4Gran[i].Centr_Mass);  //    

      Delt_Angl = AbsD(V_Point.Ugol-S.Ugol);                    // 
      if(Delt_Angl > 180) Delt_Angl = AbsD(Delt_Angl-360);      //  0
      if(Delt_Angl <= 8)                                        //   
      {
        *Ind = i;                                               //  
        return True;                                            //
      }
    }
  }
  return False;                                                 // 
}
//---------------------------------------------------------------------------
//  
double __fastcall  TDetectorO::Affine_Tr_Angle(double Ugol)
{
  TPoint      SPoint;                                           // 
  TPointPolar NPoint;                                           // 

  NPoint.Rad = 200;                                             //  
  NPoint.Ugol = Ugol+Settings.Rotation;                         //     
  //          X   
  SPoint = PolarToDecart(NPoint);                               //   
  SPoint.y = SPoint.y-Koleso.Center.y;                          // 0-    
  SPoint.x = SPoint.x-Koleso.Center.x;
  //   -   Y
  SPoint.y = Settings.Compression*SPoint.y+0.5;

  SPoint.y = SPoint.y+Koleso.Center.y;                          // 0-   
  SPoint.x = SPoint.x+Koleso.Center.x;
  NPoint = DecartToPolar(SPoint);                               //    

  return NPoint.Ugol-Settings.Rotation;                         //     
}
//---------------------------------------------------------------------------
//     
void __fastcall  TDetectorO::Add_Lost_Sector(TObj_List *Tec_L)
{
  TPointPolar     Green_Sekt;                                   //   
  int             i;                                            // 
  TPointPolar     Last_Point;                                   //    
  int             Next_Index;                                   //  
  int             Temp_Ind;                                     //    
  int             Vr;                                           // 
  int             Green_Index;                                  //  
  TPointPolar     Test;                                         //    
  double          LastU1,LastU2;                                // 

  Green_Index = Find_Green(Tec_L);                              //  
  //   
  Green_Sekt = DecartToPolar(Tec_L->Arr_4Gran[Green_Index].Centr_Mass);
  Tec_L->Arr_4Gran[Green_Index].Ord_Nomer = 1;                  //  
  Last_Point = Green_Sekt;                                      //    

  for(i=1;i<=18;i++)                                            //     
  {
    // 
    LastU1 = Affine_Tr_Angle(Last_Point.Ugol);                  //  
    LastU2 = Affine_Tr_Angle(Last_Point.Ugol+(360/37)*2);       //  
    //        
    Last_Point.Ugol = Last_Point.Ugol+(LastU2-LastU1);
    Test.Ugol = Last_Point.Ugol;                                //    
    Test.Rad = 50;                                              //
    TestP[i][1] = PolarToDecart(Test);                          // 
    Test.Rad = 70;                                              //
    TestP[i][2] = PolarToDecart(Test);                          // 
    // , 
    if(Last_Point.Ugol > 360) Last_Point.Ugol = Last_Point.Ugol-360;

    if(Find_Sektor(Last_Point, &Next_Index))                    //    
    {
      //   
      Last_Point = DecartToPolar(Tec_L->Arr_4Gran[Next_Index].Centr_Mass);
      Tec_L->Arr_4Gran[Next_Index].Ord_Nomer = i*2+1;           //  
    }
    else                                                        //   
    {
      Tec_L->Count_4Gran++;                                     //   
      Tec_L->Arr_4Gran[Tec_L->Count_4Gran].Actualn = True;      // 
      //  
      Tec_L->Arr_4Gran[Tec_L->Count_4Gran].Centr_Mass = PolarToDecart(Last_Point);
      Tec_L->Arr_4Gran[Tec_L->Count_4Gran].Metka = 'V';         // 
      Tec_L->Arr_4Gran[Tec_L->Count_4Gran].Ord_Nomer = i*2+1;   //  
    }
  }

  //    
  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             //   
    {
      //    
      if(Tec_L->Arr_4Gran[i].Ord_Nomer == 0) Tec_L->Arr_4Gran[i].Actualn = False;
    }
  }

  //  
  Vr = 0;                                                       // 
  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             //   
    {
      if(Tec_L->Arr_4Gran[i].Ord_Nomer != 37)                   // 32   
      {
        Vr++;                                                   //
        Temp_Ind = Tec_L->Count_4Gran+Vr;                       // 
        Tec_L->Arr_4Gran[Temp_Ind].Actualn = True;              // 
        //  
        Last_Point = DecartToPolar(Tec_L->Arr_4Gran[i].Centr_Mass);
        // 
        LastU1 = Affine_Tr_Angle(Last_Point.Ugol);              //  
        LastU2 = Affine_Tr_Angle(Last_Point.Ugol+360/37);       //  
        Last_Point.Ugol = Last_Point.Ugol+(LastU2-LastU1);      //  
        //  
        Tec_L->Arr_4Gran[Temp_Ind].Centr_Mass = PolarToDecart(Last_Point);
        Tec_L->Arr_4Gran[Temp_Ind].Metka = 'V';                 // 
        //  
        Tec_L->Arr_4Gran[Temp_Ind].Ord_Nomer = Tec_L->Arr_4Gran[i].Ord_Nomer+1;
      }
    }
  }
  Tec_L->Count_4Gran = Tec_L->Count_4Gran+18;                   //   

  //  
  Tec_L->Kolichestvo_Sect = 0;                                  // 
  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    //    -  
    if(Tec_L->Arr_4Gran[i].Actualn) Tec_L->Kolichestvo_Sect++;
  }
}
//---------------------------------------------------------------------------
//    
int __fastcall  TDetectorO::Analiz(void)
{
  int   i;                                                      // 
  int   Min_Rasst;                                              //   
  int   Tec_Rasst;                                              //   
  int   Fix_Nomer;                                              // 
  int   Result;                                                 //

  Result = Bol_Netu;                                            //     
  if(Bols.Ind_Bol != 0)                                         //    
  {
    Min_Rasst = 1000000;                                        //   
    Fix_Nomer = Bol_Netu;                                       //  
    for(i=1;i<=Koleso.Count_4Gran;i++)                          //  
    {
      if(Koleso.Arr_4Gran[i].Actualn)                           //  
      {
        //       -      
        if(Rasst(Bols.Arr_4Gran[Bols.Ind_Bol].Centr_Mass,Koleso.Arr_4Gran[i].Centr_Mass) < Koleso.Sred_Rad)
        {
          //    
          Tec_Rasst = Rasst_Dot_Line(Bols.Arr_4Gran[Bols.Ind_Bol].Centr_Mass,Koleso.Arr_4Gran[i].Centr_Mass,Koleso.Center);
          if(Min_Rasst >= Tec_Rasst)                            // 
          {
            Min_Rasst = Tec_Rasst;                              // 
            Fix_Nomer = Koleso.Arr_4Gran[i].Real_Nomer;         // 
          }
        }
      }
    }
    Result = Fix_Nomer;                                         //  
  }
  return Result;                                                //
}
//---------------------------------------------------------------------------
//      
void __fastcall  TDetectorO::Result_Obr(int Nom)
{
  TRes_Detector    Rez_Str;                                     // 
  int              i,j;                                         // 
  int              V_Arr[37];                                   // 
  int              Max_Col;                                     //  
  int              Rez_Nomer;                                   // 

  // 
  for(i=1;i<maxLstNom;i++) Buf_Nomer.N_Arr[maxLstNom+1-i] = Buf_Nomer.N_Arr[maxLstNom-i];
  Buf_Nomer.N_Arr[1] = Nom;                                     // 

  for(j=0;j<=36;j++) V_Arr[j] = 0;                              // 
  for(i=1;i<=maxLstNom;i++)                                     //  
  {
    //       
    if(i <= 30)
    {
      //      
      for(j=0;j<=36;j++)
      {
        //    
        if(Buf_Nomer.N_Arr[i] == j) V_Arr[j]++;
      }
    }
  }
  //    
  Max_Col = 0;                                                  //  
  Rez_Nomer = 0;                                                // 
  for(i=0;i<=36;i++)
  {
    if(V_Arr[i] > Max_Col)                                      //
    {
      Max_Col = V_Arr[i];                                       //
      Rez_Nomer = i;                                            // 
    }
  }

  //  " "
  if(Gl_Mode == mdGameOK)
  {
    if(Mov_Detector.Faktor_Starta)                              //   
    {
      Mov_Detector.Faktor_Starta = False;                       // 
      for(i=1;i<=maxLstNom;i++) Buf_Nomer.N_Arr[i] = Bol_Pusto; //  
      Max_Col = 0;                                              //  
      Gl_Mode = mdDel_St;                                       //   " "
      Rez_Str.Event_Nom = 1;                                    // 
      Rez_Str.Event_Str = " ";                     // 
      Rez_Str.Nomer = Bol_Netu;                                 // 
      Gl_Last_Nomer = Bol_Netu;                                 //  
      if(Rezult_Ev != NULL) Rezult_Ev(Rez_Str);                 //    
    }
  }

  //  " "
  if(Gl_Mode == mdDel_St)
  {
    //     
    if(Max_Col >= Settings.Edge_Nom)
    {
      Gl_Mode = mdGameOK;                                       //   " "
      //  
      for(i=1;i<=maxLstNom;i++) Buf_Nomer.N_Arr[i] = Bol_Pusto;
      Rez_Str.Event_Nom = 3;                                    // 
      Rez_Str.Event_Str = " ";                    // 
      Rez_Str.Nomer = Rez_Nomer;                                // 
      Gl_Last_Nomer = Rez_Nomer;                                //  
      if(Rezult_Ev != NULL) Rezult_Ev(Rez_Str);                 //    
    }
  }
}
//---------------------------------------------------------------------------
//    
void __fastcall  TDetectorO::Filter_Ugol(TObj_List *Tec_L)
{
  int         i,j;                                              // 
  TPointPolar Dot_A,Dot_B;                                      // 

  for(i=1;i<=Tec_L->Count_4Gran;i++)                            //    
  {
    if(Tec_L->Arr_4Gran[i].Actualn)                             //   
    {
      for(j=1;j<=Tec_L->Count_4Gran;j++)                        //    
      {
        if(Tec_L->Arr_4Gran[j].Actualn)                         //   
        {
          Dot_A = DecartToPolar(Tec_L->Arr_4Gran[i].Centr_Mass);//  
          Dot_B = DecartToPolar(Tec_L->Arr_4Gran[j].Centr_Mass);//  
          //  
          if((Dot_A.Ugol > Dot_B.Ugol-4)&&(Dot_A.Ugol < Dot_B.Ugol+4)&&(i != j))
          {
            Tec_L->Arr_4Gran[i].Actualn = False;                //   
          }
        }
      }
    }
  }
}
//---------------------------------------------------------------------------
//   
void __fastcall  TDetectorO::Speed_Detect(TObj_List *Tec_L)
{
  int       i;                                                  // 
  int       Green_Index;                                        //  
  double    Tec_Angle;                                          //  
  double    Summa;                                              // 

  if(Green_OK(Tec_L))                                           //  
  {
    Green_Index = Find_Green(Tec_L);                            //  
    //  
    Tec_Angle = DecartToPolar(Tec_L->Arr_4Gran[Green_Index].Centr_Mass).Ugol;

    if(AbsD(Tec_L->Last_Green_Ugol-Tec_Angle) < 200)            //     0
    {
      Tec_L->Last_Angle_Diff = Tec_L->Last_Green_Ugol-Tec_Angle;// 
      //  
      for(i=1;i<=29;i++) Tec_L->Ugl_Speed[i] = Tec_L->Ugl_Speed[i+1];
      Tec_L->Ugl_Speed[30] = Tec_L->Last_Angle_Diff;            // 
    }
    Tec_L->Last_Green_Ugol = Tec_Angle;                         //  
  }                                                             //  
  //   
  else Tec_L->Last_Green_Ugol = Tec_L->Last_Green_Ugol-Tec_L->Last_Angle_Diff;

  Summa = 0;                                                    //
  for(i=1;i<=30;i++) Summa += Tec_L->Ugl_Speed[i];              //
  Summa = Summa/30;                                             // 
  Will_Speed = Summa*10*60/360;                                 //    

  //   
  if(Tec_L->Ugl_Speed_OK)                                       //   
  {
    //    //Settings.OffAngSpd
    if(AbsD(Will_Speed) <= 1) Tec_L->Ugl_Speed_OK = False;
  }
  else                                                          //  
  {
    //    //Settings.OffAngSpd+2
    if(AbsD(Will_Speed) >= 2) Tec_L->Ugl_Speed_OK = True;
  }
}
//---------------------------------------------------------------------------
//    
void __fastcall  TDetectorO::Color_Lev(void)
{
  int     i;                                                    //
  TPoint  Scan_P;                                               // 
  TColor  Color;                                                //  
  Byte    RV,GV,BV;                                             //
  Byte    Max_RG,Max_RB,Max_GB;                                 //  
  int     Summ_RG,Summ_RB,Summ_GB;                              //  

  Max_RG = 0;                                                   //  
  Max_RB = 0;
  Max_GB = 0;

  Scan_P.y = 0;                                                 //   
  while(Scan_P.y <= Gl_Height)                                  // 
  {
    Scan_P.x = 0;                                               //   
    while(Scan_P.x <= Gl_Width)                                 // 
    {
      Color = Rd_Dot(Scan_P.x,Scan_P.y);                        //  
      RV = GetRValue(Color);                                    // 
      GV = GetGValue(Color);
      BV = GetBValue(Color);

      if(abs(RV-GV) > Max_RG) Max_RG = abs(RV-GV);              // 
      if(abs(RV-BV) > Max_RB) Max_RB = abs(RV-BV);
      if(abs(GV-BV) > Max_GB) Max_GB = abs(GV-BV);

      Scan_P.x = Scan_P.x+3;                                    //  
    }
    Scan_P.y = Scan_P.y+3;                                      //  
  }

  ColP_Buf.Bf_RG[ColP_Buf.Pointer] = Max_RG;                    //   
  ColP_Buf.Bf_RB[ColP_Buf.Pointer] = Max_RB;
  ColP_Buf.Bf_GB[ColP_Buf.Pointer] = Max_GB;
  ColP_Buf.Pointer++;                                           //   
  if(ColP_Buf.Pointer > szColPB) ColP_Buf.Pointer = 1;          //

  Summ_RG = 0;                                                  //  
  Summ_RB = 0;
  Summ_GB = 0;
  for(i=1;i<=szColPB;i++)                                       // 
  {
    Summ_RG = Summ_RG+ColP_Buf.Bf_RG[i];                        //  
    Summ_RB = Summ_RB+ColP_Buf.Bf_RB[i];
    Summ_GB = Summ_GB+ColP_Buf.Bf_GB[i];
  }
  Summ_RG = (double)Summ_RG/szColPB+0.5;                        //
  Summ_RB = (double)Summ_RB/szColPB+0.5;
  Summ_GB = (double)Summ_GB/szColPB+0.5;

  Col_Porog.Red_G   = (Summ_RG*Settings.MaxPl_RG) / 100;        // 
  Col_Porog.Red_B   = (Summ_RB*Settings.MaxPl_RB) / 100;
  Col_Porog.Green_R = (Summ_RG*Settings.MaxPl_GR) / 100;
  Col_Porog.Green_B = (Summ_GB*Settings.MaxPl_GB) / 100;
}
//---------------------------------------------------------------------------
// 
void __fastcall  TDetectorO::Processing(void)
{
  int    i;                                                     // 
  int    K_X,K_Y,D_X,D_Y;                                       //     
  int    K_R,D_R;                                               //

  if(Init_OK)                                                   //   
  {
    Error_Str = "OK";                                           // 
    Koleso.Count_4Gran = 0;                                     //    
    Bols.Count_4Gran = 0;                                       //    

    if(ColP_Buf.Taimer <= 0)                                    //   
    {
      ColP_Buf.Taimer = 2;                                      //    
      Color_Lev();                                              //    
    }
    else ColP_Buf.Taimer--;                                     // 

    Scan(&Koleso,Color_Green,'G');                              //   
    Scan(&Koleso,Color_Red,'R');                                //   
    Filter_Area(&Koleso);                                       //   
    Detect_Center(&Koleso);                                     //  
    Filter_Obj_Rast(&Koleso);                                   //    
    Detect_Center(&Koleso);                                     //    
    Filter_Ugol(&Koleso);                                       //    
    Work_Mov_Detector(&Mov_Detector);                           //   

    if((Koleso.Center.x!=0)&&(Koleso.Center.y!=0))              //   
    {
      Ult_Center(&Koleso);                                      //     
      Koleso.Center = Koleso_Centr_Buf(Koleso.Center);          //    
      Speed_Detect(&Koleso);                                    //   
      if(!Settings.Alt_White) Scan_Shar(&Bols,Color_White);     //  
      else                    Scan_Shar(&Bols,Alt_Color_White); // 
      Filt_Koord_Shar(&Bols);                                   //   
      SelMaxGreen(&Koleso);                                     //     

      K_X = Koleso.Center.x;                                    // 
      K_Y = Koleso.Center.y;
      K_R = Koleso.Sred_Rad;                                    // 
      D_X = Mov_Detector.Center.x;                              //  
      D_Y = Mov_Detector.Center.y;
      D_R = Mov_Detector.Radius;                                // 
      //      10     15 
      if((D_X<K_X-10)||(D_X>K_X+10)||(D_Y<K_Y-10)||(D_Y>K_Y+10)||(D_R<K_R-15)||(D_R>K_R+15)||(Settings.ApdMD==1))
      {
        Mov_Detector.Center = Koleso.Center;                    // 
        Mov_Detector.Radius = Koleso.Sred_Rad;                  // 
        //    
        Settings.Compression = sqrt(1-SQR(Settings.Eccentricity));
        //   
        Build_Mov_Detector(&Mov_Detector,Settings.Eccentricity,Settings.Rotation);
        //   
        Build_Bols_Area(Settings.Eccentricity,Settings.Rotation);
        Settings.ApdMD = 0;                                     // 
      }

      if(Green_OK(&Koleso))                                     //  
      {
        Add_Lost_Sector(&Koleso);                               //     
        if(Koleso.Kolichestvo_Sect == 37)                       //  
        {
          //   
          for(i=1;i<=Koleso.Count_4Gran;i++)                    //    
          {
            if(Koleso.Arr_4Gran[i].Actualn)                     //    - 
            {
              // 
              if((Koleso.Arr_4Gran[i].Ord_Nomer >= 1)&&(Koleso.Arr_4Gran[i].Ord_Nomer <= 37))
              {
                // 
                Koleso.Arr_4Gran[i].Real_Nomer = Real_N[Koleso.Arr_4Gran[i].Ord_Nomer-1];
              } else Koleso.Arr_4Gran[i].Real_Nomer = -1;       // 
            }
          }
          //   
          if(Koleso.Ugl_Speed_OK) Result_Obr(Analiz());         //      
        }
        else Error_Str = "  ";
      }
      else Error_Str = " ";
    }
    else Error_Str = "  ";

    //    
    if(Color_Rd) { Color_Gr = False; Color_Wh = False; }
    if(Color_Gr) { Color_Rd = False; Color_Wh = False; }
    if(Color_Wh) { Color_Gr = False; Color_Rd = False; }

    if(Color_Rd) Col_Filter(Color_Red,clRed);                   //     
    if(Color_Gr) Col_Filter(Color_Green,clLime);                //     
    if(Color_Wh)                                                //     
    {
      if(Settings.Alt_White == 0) Col_Filter(Color_White,clWhite);      // 
      else                        Col_Filter(Alt_Color_White,clWhite);  //
    }
    if(Debug_Inf) Oformlenie();                                 //   
  }
}

