//---------------------------------------------------------------------------

#ifndef DecoderUH
#define DecoderUH

#include <Typedefs.h>                                           //  
//---------------------------------------------------------------------------
#define            MaxAreaSz   400                              //   
#define            Bol_Netu    100                              //  
#define            Bol_Pusto   200                              //  
#define            maxSList    100                              //   
#define            szColPB     10                               //   
#define            maxLstNom   100                              //   
#define            RAD         ((double)360/(2*M_PI))           //    
//-----------------
const int   Real_N[38] =                                        //   
  {0,26,3,35,12,28,7,29,18,22,9,31,14,20,1,33,16,24,5,
   10,23,8,30,11,36,13,27,6,34,17,25,2,21,4,19,15,32
  };
//-----------------
const Byte  Bol_1_Matr[10][10] =                                //   
  {{2,2,2,2,2,2,2,2,2},
   {2,0,0,1,1,1,0,0,2},
   {2,0,1,1,1,1,1,0,2},
   {2,1,1,3,3,3,1,1,2},
   {2,1,1,3,3,3,1,1,2},
   {2,1,1,3,3,3,1,1,2},
   {2,0,1,1,1,1,1,0,2},
   {2,0,0,1,1,1,0,0,2},
   {2,2,2,2,2,2,2,2,2}
  };
//-----------------
const Byte  Bol_2_Matr[12][12] =                                //   
  {{2,2,2,2,2,2,2,2,2,2,2},
   {2,2,0,0,1,1,1,0,0,2,2},
   {2,0,0,1,1,1,1,1,0,0,2},
   {2,0,1,1,1,3,1,1,1,0,2},
   {2,1,1,1,3,3,3,1,1,1,2},
   {2,1,1,3,3,3,3,3,1,1,2},
   {2,1,1,1,3,3,3,1,1,1,2},
   {2,0,1,1,1,3,1,1,1,0,2},
   {2,0,0,1,1,1,1,1,0,0,2},
   {2,2,0,0,1,1,1,0,0,2,2},
   {2,2,2,2,2,2,2,2,2,2,2}
  };
//-----------------
const Byte  Bol_3_Matr[14][14] =                                //   
  {{0,2,2,2,2,2,2,2,2,2,2,2,0},
   {2,2,0,0,0,1,1,1,0,0,0,2,2},
   {2,0,0,1,1,1,1,1,1,1,0,0,2},
   {2,0,1,1,1,3,3,3,1,1,1,0,2},
   {2,0,1,1,3,3,3,3,3,1,1,0,2},
   {2,1,1,3,3,3,3,3,3,3,1,1,2},
   {2,1,1,3,3,3,3,3,3,3,1,1,2},
   {2,1,1,3,3,3,3,3,3,3,1,1,2},
   {2,0,1,1,3,3,3,3,3,1,1,0,2},
   {2,0,1,1,1,3,3,3,1,1,1,0,2},
   {2,0,0,1,1,1,1,1,1,1,0,0,2},
   {2,2,0,0,0,1,1,1,0,0,0,2,2},
   {0,2,2,2,2,2,2,2,2,2,2,2,0}
  };
//-----------------
typedef Byte *TBufer_Kadra;                                     //  
//-----------------
typedef struct                                                  //    
{ int              Min_R[361];                                  // 
  int              Max_R[361];                                  // 
} TBols_Area;
//-----------------
typedef struct                                                  // 
{ Byte             MaxPl_RG;                                    //   
  Byte             MaxPl_RB;
  Byte             MaxPl_GR;
  Byte             MaxPl_GB;
  Byte             Wh_Pers;                                     //   
  Byte             OffAngSpd;                                   //  
  Byte             Edge_Nom;                                    //   
  Byte             Alt_White;                                   //   
  Byte             Alt_Level;                                   //   
  Byte             ApdMD;                                       //    
  double           Eccentricity;                                // (  )
  double           Compression;                                 //.   (  )
  int              Rotation;                                    //  
  int              MatrixLev;                                   //    
  int              ML_1;                                        //  
  int              ML_2;
  int              ML_3;
  Byte             ClWhDelt;                                    //    
  Byte             MaxRBolAr;                                   //    
} TSettings;
//-----------------
typedef struct                                                  //    
{ Byte             Bf_RG[szColPB+1];                            //  
  Byte             Bf_RB[szColPB+1];
  Byte             Bf_GB[szColPB+1];
  Byte             Pointer;                                     //  
  int              Taimer;                                      //   
} TColP_Buf;
//-----------------
typedef struct                                                  // 
{ TPoint           St_Arr[6];                                   //
  int              St_Ind;                                      // 
} TSt_P;
//-----------------
typedef struct                                                  //     
{ TRect            Var_Rect;                                    // 
  Char             T_Metka;                                     // 
} TK_4G;
//-----------------
typedef struct                                                  //  
{ TRect            Grani;                                       // 
  int              SzArea;                                      //
  TPoint           Centr_Mass;                                  // 
  int              Rasst_Center;                                //  
  TPoint           Var_Point;                                   //    
  Char             Metka;                                       //
  int              Ord_Nomer;                                   //   
  int              Real_Nomer;                                  // 
  int              Matrix_ID;                                   //ID   ( )
  int              DistToLastB;                                 //   
  bool             Actualn;                                     // 
} T4Gran;
//-----------------
typedef struct                                                  // 
{ T4Gran           Arr_4Gran[maxSList+1];                       // 
  int              Count_4Gran;                                 //   
  int              Ind_Bol;                                     //  
  TPoint           Center;                                      // 
  int              Sred_Rad;                                    // 
  int              Kolichestvo_Sect;                            // 
  double           Last_Green_Ugol;                             //   
  double           Last_Angle_Diff;                             //   
  TPoint           LastPBol;                                    //   
  double           Ugl_Speed[31];                               //  
  bool             Ugl_Speed_OK;                                //    
} TObj_List;
//-----------------
typedef struct                                                  // 
{ TPoint           Dots[11];                                    // 
  int              Old_Osv_Dots[11];                            //   
  bool             OldCond[21];                                 //  
  bool             Blocked;                                     // 
  int              Kol_Srab;                                    //  
  bool             Bol;                                         //  
} TDet;
//-----------------
typedef struct                                                  // 
{ TDet             Arr_Det[181];                                //  
  TPoint           Center;                                      //  
  int              Radius;                                      // 
  int              St_Koord[11];                                //   
  bool             Faktor_Starta;                               //  
  int              Old_Poz;                                     //   
} TMov_Detector;
//-----------------
typedef struct                                                  //   
{ int              Rad;                                         //
  double           Ugol;                                        //
} TPointPolar;
//-----------------
typedef struct                                                  //  
{ TPoint           Dots[71];                                    //
  int              Ind;                                         //   
} TCenter_Bufer;
//-----------------
typedef struct                                                  // 
{ int              N_Arr[maxLstNom+1];                          //
} TBuf_Nomer;
//-----------------
typedef struct                                                  // 
{ int              Event_Nom;                                   // 
  String           Event_Str;                                   //  
  int              Nomer;                                       // 
} TRes_Detector;
//-----------------
typedef struct                                                  // 
{ Byte             Red_Max;                                     // 
  Byte             Red_G,Red_B;                                 //  
  Byte             Green_Max;                                   // 
  Byte             Green_R,Green_B;                             //  
  Byte             BW_Max;                                      // 
  int              BW_Tec_Val;                                  //   
} TColor_Porog;
//-----------------
typedef TPoint TBols_Stek[51][11];                              // 
//-----------------
typedef struct                                                  //   
{ TBols_Stek       Bols_St;                                     //  
  int              WrP_Fr;                                      //     
  int              WrP_Bl;                                      //     
} TBols_Koord;
//-----------------
enum  TG_Mode {mdGame,mdGameOK,mdDel_St,mdStavok_Net};          // 
//-----------------
typedef Byte __fastcall (__closure *TF_Col)(TPoint Dot);        // 
//-----------------
//  
typedef void __fastcall (__closure *TF_Decoder_Rez)(TRes_Detector Res);
//-----------------
// 
class TDetectorO : public TObject
{
private: // User declarations
        TPoint               TestP[51][3];                      // 
        TBols_Area           Bols_Area;                         //    
        bool                 Init_OK;                           // 
        TF_Decoder_Rez       Rezult_Ev;                         // 
        TMov_Detector        Mov_Detector;                      // 
        TBufer_Kadra         Gl_Buf;                            //   
        int                  Gl_Width,Gl_Height;                //    
        TBols_Koord          Bols_Koord;                        //   
        int                  Gl_Last_Nomer;                     //  
        int                  Color_An_Frame;                    //     
        TColor_Porog         Col_Porog;                         // 
        TG_Mode              Gl_Mode;                           // 
        TCenter_Bufer        Center_Bufer;                      //  
        TBuf_Nomer           Buf_Nomer;                         // 
        TSt_P                StP;                               // 
        Byte                 Rab_Arr[MaxAreaSz][MaxAreaSz];     //  
        Graphics::TBitmap   *Text_Im;                           //  
        TK_4G                K_4G;                              //  
        TObj_List            Koleso;                            //  
        TObj_List            Bols;                              // ,   
        TColP_Buf            ColP_Buf;                          //    

        //    
        bool __fastcall      IsSingle(TMov_Detector *Det, int APoz);
        //   
        bool __fastcall      IsItMovBol(TMov_Detector *Det, int FreshPoz);
        int __fastcall       SizeMovObj(TMov_Detector *Det);    //  
        int __fastcall       RingDistance180(int T1, int T2);   //       180 
        int __fastcall       RingDistance180Abs(int T1, int T2);//        180 
        //   
        void __fastcall      Work_Mov_Detector(TMov_Detector *Det);
        TColor __fastcall    Rd_Dot(int X, int Y);              // 
        //   
        void __fastcall      Build_Mov_Detector(TMov_Detector *Det, double Ecc, int Rot);
        double __fastcall    SQR(double X);            //  
        TPointPolar __fastcall DecartToPolar(TPoint A);         //     
        TPoint __fastcall    PolarToDecart(TPointPolar A);      //     
        //   
        void __fastcall      Build_Bols_Area(double Ecc, int Rot);
        //     
        bool __fastcall      Find_Near_InSt(TBols_Stek Stek, TPoint Bol);
        //    
        int __fastcall       Rasst_Dot_Line(TPoint X, TPoint A, TPoint B);
        int __fastcall       Rasst(TPoint A, TPoint B);         //  
        void __fastcall      Filt_Koord_Shar(TObj_List *Tec_L); //   
        void __fastcall      Pr_Zalivka(void);                  //     
        //   
        TColor __fastcall    Rd_CDot(Graphics::TBitmap *Bitm, int X, int  Y);
        //    
        void __fastcall      Col_Filter(TF_Col F_Color, TColor Color);
        void __fastcall      Alone_Dot_Filter(int K_Faktor);    //  
        void  __fastcall     Wr_Dot(int X, int Y, TColor Color);// 
        void __fastcall      Ult_Center(TObj_List *Tec_L);      //     
        void __fastcall      Sredn_Rad(TObj_List *Tec_L);       //      
        TPoint __fastcall    Koleso_Centr_Buf(TPoint A);        //    
        //       ,    
        //    
        TPoint __fastcall    Vektor(TPoint A, TPoint B, int R);
        void __fastcall      Speed_Detect(TObj_List *Tec_L);    //   
        bool __fastcall      Green_OK(TObj_List *Tec_L);        //    
        int __fastcall       Find_Green(TObj_List *Tec_L);      //   
        void __fastcall      Color_Lev(void);                   //    
        void __fastcall      Result_Obr(int Nom);               //      
        void __fastcall      Filter_Ugol(TObj_List *Tec_L);     //    
        void __fastcall      Add_Lost_Sector(TObj_List *Tec_L); //     
        double __fastcall    Affine_Tr_Angle(double Ugol);      //  
        //     
        bool __fastcall      Find_Sektor(TPointPolar S, int *Ind);
        int __fastcall       Analiz(void);                      //    
        void __fastcall      Filter_Area(TObj_List *Tec_L);     //   
        void __fastcall      SelMaxGreen(TObj_List *Tec_L);     //     
        void  __fastcall     Gr_Center(T4Gran *Gr);             // 
        void  __fastcall     Gr_Area(T4Gran *Gr);               // 
        // 
        void  __fastcall     Wr_Label(int X, int Y, String Txt, TColor Color);
        //     
        bool  __fastcall     Dot_In_All_4Gr(TObj_List *ObjL, TPoint Dot);
        bool  __fastcall     Dot_In_4Gr(T4Gran Gr, TPoint Dot); //    
        void  __fastcall     Create_4Gran(TObj_List *ObjL);     // 
        //   
        void __fastcall      Detect_Center(TObj_List *Tec_L);
        //  
        void __fastcall      Oforml_Bol(T4Gran Bol, TColor Color);
        // 
        void  __fastcall     Wr_Line(int X1, int Y1, int X2, int Y2, TColor Color);
        // 
        void  __fastcall     Wr_Rect(int X, int Y, int W, int H, TColor Color);
        void __fastcall      Oformlenie(void);                  //   
        void __fastcall      Filter_Obj_Rast(TObj_List *Tec_L); //    
        bool  __fastcall     Dot_Color_OK(TPoint Tec_Dot);      //    
        void  __fastcall     Point_Gran(int X, int Y);          //  
        void  __fastcall     St_PUSH(TPoint Dot);               //  
        bool  __fastcall     St_POP(TPoint *Dot);               //  
        //        
        bool  __fastcall     Sosedi_OK(TPoint Dot, int Kol_S);
        //       
        void  __fastcall     Area_4Gr(TObj_List *Tec_L, TPoint Start);
        Byte  __fastcall     Color_Green(TPoint Tec_Dot);       //   
        Byte  __fastcall     Color_Red(TPoint Tec_Dot);         //   
        Byte  __fastcall     Color_White(TPoint Tec_Dot);       //   
        Byte  __fastcall     Alt_Color_White(TPoint Tec_Dot);   //    
        //        
        void __fastcall      Matrix_Bol(TObj_List *Tec_L, TPoint St_Point);
        //    
        void __fastcall      Scan_Shar(TObj_List *Tec_L, TF_Col F_Color);
        //       
        void __fastcall      Scan(TObj_List *Tec_L, TF_Col F_Color, Char Metka);
        double __fastcall    AbsD(double X);                    //   double
public:	 // User declarations
        TSettings            Settings;                          // 
        String               Error_Str;                         // 
        double               Will_Speed;                        //  
        bool                 Color_Rd,Color_Gr,Color_Wh;        //  
        bool                 Debug_Inf;                         //  

        //  ,      
        void __fastcall      Set_Parameter(Byte *Data, int Width, int Height, TF_Decoder_Rez Func);
        void __fastcall      Processing(void);                  // 
        void __fastcall      DefSettings(void);                 //  
        void __fastcall      SeveSettings(void);                //            
        __fastcall           TDetectorO(void);                  //
        __fastcall          ~TDetectorO(void);                  //
};
#endif
